Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.4.2.2.3
retrieving revision 1.1.1.3.4.2.2.3.2.1
diff -u -r1.1.1.3.4.2.2.3 -r1.1.1.3.4.2.2.3.2.1
--- squid/src/structs.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.2.2.3
+++ squid/src/structs.h	27 Aug 2001 21:48:22 -0000	1.1.1.3.4.2.2.3.2.1
@@ -1561,14 +1804,18 @@
     char *redirect_url;
     ERCB *callback;
     void *callback_data;
-    struct {
+    struct
+    {
 	unsigned int flag_cbdata:1;
-    } flags;
-    struct {
+    }
+    flags;
+    struct
+    {
 	wordlist *server_msg;
 	char *request;
 	char *reply;
-    } ftp;
+    }
+    ftp;
     char *request_hdrs;
 };
 
@@ -1576,7 +1823,8 @@
  * "very generic" histogram; 
  * see important comments on hbase_f restrictions in StatHist.c
  */
-struct _StatHist {
+struct _StatHist
+{
     int *bins;
     int capacity;
     double min;
@@ -1590,8 +1838,10 @@
  * if you add a field to StatCounters, 
  * you MUST sync statCountersInitSpecial, statCountersClean, and statCountersCopy
  */
-struct _StatCounters {
-    struct {
+struct _StatCounters
+{
+    struct
+    {
 	int clients;
 	int requests;
 	int hits;
@@ -1604,16 +1854,22 @@
 	StatHist nh_svc_time;
 	StatHist hit_svc_time;
 	StatHist all_svc_time;
-    } client_http;
-    struct {
-	struct {
+    }
+    client_http;
+    struct
+    {
+	struct
+	{
 	    int requests;
 	    int errors;
 	    kb_t kbytes_in;
 	    kb_t kbytes_out;
-	} all , http, ftp, other;
-    } server;
-    struct {
+	}
+	all   , http, ftp, other;
+    }
+    server;
+    struct
+    {
 	int pkts_sent;
 	int queries_sent;
 	int replies_sent;
@@ -1634,14 +1890,20 @@
 	StatHist reply_svc_time;
 	int query_timeouts;
 	int times_used;
-    } icp;
-    struct {
+    }
+    icp;
+    struct
+    {
 	int requests;
-    } unlink;
-    struct {
+    }
+    unlink;
+    struct
+    {
 	StatHist svc_time;
-    } dns;
-    struct {
+    }
+    dns;
+    struct
+    {
 	int times_used;
 	kb_t kbytes_sent;
 	kb_t kbytes_recv;
@@ -1652,10 +1914,13 @@
 	cd_guess_stats guess;
 #endif
 	StatHist on_xition_count;
-    } cd;
-    struct {
+    }
+    cd;
+    struct
+    {
 	int times_used;
-    } netdb;
+    }
+    netdb;
     int page_faults;
     int select_loops;
     int select_fds;
@@ -1666,16 +1931,20 @@
     StatHist comm_dns_incoming;
     StatHist comm_http_incoming;
     StatHist select_fds_hist;
-    struct {
-	struct {
+    struct
+    {
+	struct
+	{
 	    int opens;
 	    int closes;
 	    int reads;
 	    int writes;
 	    int seeks;
 	    int unlinks;
-	} disk;
-	struct {
+	}
+	disk;
+	struct
+	{
 	    int accepts;
 	    int sockets;
 	    int connects;
@@ -1685,19 +1954,22 @@
 	    int writes;
 	    int recvfroms;
 	    int sendtos;
-	} sock;
+	}
+	sock;
 #if HAVE_POLL
 	int polls;
 #else
 	int selects;
 #endif
-    } syscalls;
+    }
+    syscalls;
     int swap_files_cleaned;
     int aborted_requests;
 };
 
 /* per header statistics */
-struct _HttpHeaderStat {
+struct _HttpHeaderStat
+{
     const char *label;
     HttpHeaderMask *owner_mask;
 
@@ -1712,14 +1984,16 @@
 };
 
 
-struct _tlv {
+struct _tlv
+{
     char type;
     int length;
     void *value;
     tlv *next;
 };
 
-struct _storeSwapLogData {
+struct _storeSwapLogData
+{
     char op;
     sfileno swap_file_number;
     time_t timestamp;
@@ -1733,14 +2007,16 @@
 };
 
 /* object to track per-action memory usage (e.g. #idle objects) */
-struct _MemMeter {
+struct _MemMeter
+{
     ssize_t level;		/* current level (count or volume) */
     ssize_t hwater_level;	/* high water mark */
     time_t hwater_stamp;	/* timestamp of last high water mark change */
 };
 
 /* object to track per-pool memory usage (alloc = inuse+idle) */
-struct _MemPoolMeter {
+struct _MemPoolMeter
+{
     MemMeter alloc;
     MemMeter inuse;
     MemMeter idle;
@@ -1749,34 +2025,41 @@
 };
 
 /* a pool is a [growing] space for objects of the same size */
-struct _MemPool {
+struct _MemPool
+{
     const char *label;
     size_t obj_size;
     Stack pstack;		/* stack for free pointers */
     MemPoolMeter meter;
 };
 
-struct _ClientInfo {
+struct _ClientInfo
+{
     /* first two items must be equivalent to hash_link */
     char *key;
     ClientInfo *next;
     struct in_addr addr;
-    struct {
+    struct
+    {
 	int result_hist[LOG_TYPE_MAX];
 	int n_requests;
 	kb_t kbytes_in;
 	kb_t kbytes_out;
 	kb_t hit_kbytes_out;
-    } Http, Icp;
-    struct {
+    }
+    Http  , Icp;
+    struct
+    {
 	time_t time;
 	int n_req;
 	int n_denied;
-    } cutoff;
+    }
+    cutoff;
     int n_established;		/* number of current established connections */
 };
 
-struct _CacheDigest {
+struct _CacheDigest
+{
     /* public, read-only */
     char *mask;			/* bit mask */
     size_t mask_size;		/* mask size in bytes */
@@ -1786,13 +2069,15 @@
     int del_count;		/* number of deletions performed so far */
 };
 
-struct _FwdServer {
+struct _FwdServer
+{
     peer *peer;			/* NULL --> origin server */
     hier_code code;
     FwdServer *next;
 };
 
-struct _FwdState {
+struct _FwdState
+{
     int client_fd;
     StoreEntry *entry;
     request_t *request;
@@ -1801,36 +2086,43 @@
     ErrorState *err;
     time_t start;
     int n_tries;
-    struct {
+    struct
+    {
 	unsigned int dont_retry:1;
 	unsigned int ftp_pasv_failed:1;
-    } flags;
+    }
+    flags;
 };
 
 #if USE_HTCP
-struct _htcpReplyData {
+struct _htcpReplyData
+{
     int hit;
     HttpHeader hdr;
     u_num32 msg_id;
     double version;
-    struct {
+    struct
+    {
 	/* cache-to-origin */
 	double rtt;
 	int samp;
 	int hops;
-    } cto;
+    }
+    cto;
 };
 
 #endif
 
 
-struct _helper_request {
+struct _helper_request
+{
     char *buf;
     HLPCB *callback;
     void *data;
 };
 
-struct _helper {
+struct _helper
+{
     wordlist *cmdline;
     dlink_list servers;
     dlink_list queue;
@@ -1839,15 +2131,18 @@
     int n_running;
     int ipc_type;
     time_t last_queue_warn;
-    struct {
+    struct
+    {
 	int requests;
 	int replies;
 	int queue_size;
 	int avg_svc_time;
-    } stats;
+    }
+    stats;
 };
 
-struct _helper_server {
+struct _helper_server
+{
     int index;
     int rfd;
     int wfd;
@@ -1859,26 +2154,36 @@
     dlink_node link;
     helper *parent;
     helper_request *request;
-    struct _helper_flags {
+    struct _helper_flags
+    {
 	unsigned int alive:1;
 	unsigned int busy:1;
 	unsigned int closing:1;
 	unsigned int shutdown:1;
-    } flags;
-    struct {
+    }
+    flags;
+    struct
+    {
 	int uses;
-    } stats;
+    }
+    stats;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+#endif
 };
 
 /*
  * use this when you need to pass callback data to a blocking
  * operation, but you don't want to add that pointer to cbdata
  */
-struct _generic_cbdata {
+struct _generic_cbdata
+{
     void *data;
 };
 
-struct _store_rebuild_data {
+struct _store_rebuild_data
+{
     int objcount;		/* # objects successfully reloaded */
     int expcount;		/* # objects expired */
     int scancount;		/* # entries scanned or read from state file */
Index: squid/src/test-ellipses.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/test-ellipses.pl,v
retrieving revision 1.1.1.1.44.1
retrieving revision 1.1.1.1.44.1.2.1
diff -u -r1.1.1.1.44.1 -r1.1.1.1.44.1.2.1
--- squid/src/test-ellipses.pl	6 Jan 2001 12:40:17 -0000	1.1.1.1.44.1
+++ squid/src/test-ellipses.pl	27 Aug 2001 21:48:22 -0000	1.1.1.1.44.1.2.1
@@ -1,7 +1,7 @@
 #!/usr/local/bin/perl -w
 use strict;
 
-# $Id: test-ellipses.pl,v 1.1.1.1.44.1 2001/01/06 12:40:17 hno Exp $
+# $Id: test-ellipses.pl,v 1.1.1.1.44.1.2.1 2001/08/27 21:48:22 tolsty Exp $
 
 #
 # Replaces printf-like function calls with printf and compiles with gcc -Wall
Index: squid/src/test_cache_digest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/test_cache_digest.c,v
retrieving revision 1.1.1.1.4.1.2.1
retrieving revision 1.1.1.1.4.1.2.1.2.1
diff -u -r1.1.1.1.4.1.2.1 -r1.1.1.1.4.1.2.1.2.1
--- squid/src/test_cache_digest.c	6 Jan 2001 12:40:17 -0000	1.1.1.1.4.1.2.1
+++ squid/src/test_cache_digest.c	27 Aug 2001 21:48:22 -0000	1.1.1.1.4.1.2.1.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: test_cache_digest.c,v 1.1.1.1.4.1.2.1 2001/01/06 12:40:17 hno Exp $
+ * $Id: test_cache_digest.c,v 1.1.1.1.4.1.2.1.2.1 2001/08/27 21:48:22 tolsty Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -38,16 +37,19 @@
 
 #include "squid.h"
 #include "hash.h"
-typedef struct {
+typedef struct
+{
     int query_count;
     int true_hit_count;
     int true_miss_count;
     int false_hit_count;
     int false_miss_count;
-} CacheQueryStats;
+}
+CacheQueryStats;
 
 typedef struct _Cache Cache;
-struct _Cache {
+struct _Cache
+{
     const char *name;
     hash_table *hash;
     CacheDigest *digest;
@@ -60,27 +62,34 @@
 };
 
 
-typedef struct _CacheEntry {
+typedef struct _CacheEntry
+{
     const cache_key *key;
     struct _CacheEntry *next;
     unsigned char key_arr[MD5_DIGEST_CHARS];
     /* storeSwapLogData s; */
-} CacheEntry;
+}
+CacheEntry;
 
 /* parsed access log entry */
-typedef struct {
+typedef struct
+{
     cache_key key[MD5_DIGEST_CHARS];
     time_t timestamp;
     short int use_icp;		/* true/false */
-} RawAccessLogEntry;
+}
+RawAccessLogEntry;
 
-typedef enum {
+typedef enum
+{
     frError = -2, frMore = -1, frEof = 0, frOk = 1
-} fr_result;
+}
+fr_result;
 typedef struct _FileIterator FileIterator;
 typedef fr_result(*FI_READER) (FileIterator * fi);
 
-struct _FileIterator {
+struct _FileIterator
+{
     const char *fname;
     FILE *file;
     time_t inner_time;		/* timestamp of the current entry */
@@ -96,8 +105,7 @@
 static time_t cur_time = -1;	/* timestamp of the current log entry */
 
 /* copied from url.c */
-const char *RequestMethodStr[] =
-{
+const char *RequestMethodStr[] = {
     "NONE",
     "GET",
     "POST",
@@ -107,6 +115,7 @@
     "TRACE",
     "PURGE"
 };
+
 /* copied from url.c */
 static method_t
 methodStrToId(const char *s)
@@ -266,7 +275,8 @@
     struct timeval t_start, t_end;
 
     assert(cache);
-    fprintf(stderr, "%s: init-ing digest with %d entries\n", cache->name, cache->count);
+    fprintf(stderr, "%s: init-ing digest with %d entries\n", cache->name,
+	cache->count);
     if (cache->digest)
 	cacheDigestDestroy(cache->digest);
     hash = cache->hash;
@@ -322,22 +332,21 @@
 {
     fprintf(stdout, "%s: peer queries: %d (%d%%)\n",
 	cache->name,
-	stats->query_count, xpercentInt(stats->query_count, cache->req_count)
-	);
+	stats->query_count, xpercentInt(stats->query_count, cache->req_count));
     fprintf(stdout, "%s: t-hit: %d (%d%%) t-miss: %d (%d%%) t-*: %d (%d%%)\n",
 	cache->name,
-	stats->true_hit_count, xpercentInt(stats->true_hit_count, stats->query_count),
-	stats->true_miss_count, xpercentInt(stats->true_miss_count, stats->query_count),
-	stats->true_hit_count + stats->true_miss_count,
-	xpercentInt(stats->true_hit_count + stats->true_miss_count, stats->query_count)
-	);
+	stats->true_hit_count, xpercentInt(stats->true_hit_count,
+stats->query_count), stats->true_miss_count, xpercentInt(stats->true_miss_count,
+	    stats->query_count), stats->true_hit_count + stats->true_miss_count,
+	xpercentInt(stats->true_hit_count + stats->true_miss_count,
+	    stats->query_count));
     fprintf(stdout, "%s: f-hit: %d (%d%%) f-miss: %d (%d%%) f-*: %d (%d%%)\n",
-	cache->name,
-	stats->false_hit_count, xpercentInt(stats->false_hit_count, stats->query_count),
-	stats->false_miss_count, xpercentInt(stats->false_miss_count, stats->query_count),
+	cache->name, stats->false_hit_count, xpercentInt(stats->false_hit_count,
+	    stats->query_count), stats->false_miss_count,
+	xpercentInt(stats->false_miss_count, stats->query_count),
 	stats->false_hit_count + stats->false_miss_count,
-	xpercentInt(stats->false_hit_count + stats->false_miss_count, stats->query_count)
-	);
+	xpercentInt(stats->false_hit_count + stats->false_miss_count,
+	    stats->query_count));
 }
 
 static void
@@ -369,7 +378,8 @@
 	return frEof;
     fi->inner_time = entry->lastref;
     if (entry->op != SWAP_LOG_ADD && entry->op != SWAP_LOG_DEL) {
-	fprintf(stderr, "%s:%d: unknown swap log action\n", fi->fname, fi->line_count);
+	fprintf(stderr, "%s:%d: unknown swap log action\n", fi->fname,
+	    fi->line_count);
 	exit(-3);
     }
     return frOk;
@@ -492,8 +502,7 @@
 static int
 usage(const char *prg_name)
 {
-    fprintf(stderr, "usage: %s <access_log> <swap_state> ...\n",
-	prg_name);
+    fprintf(stderr, "usage: %s <access_log> <swap_state> ...\n", prg_name);
     return -1;
 }
 
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.1.1.3.4.1.2.6
retrieving revision 1.1.1.3.4.1.2.6.2.1
diff -u -r1.1.1.3.4.1.2.6 -r1.1.1.3.4.1.2.6.2.1
--- squid/src/tools.c	29 Jul 2001 16:06:05 -0000	1.1.1.3.4.1.2.6
+++ squid/src/tools.c	27 Aug 2001 21:48:22 -0000	1.1.1.3.4.1.2.6.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: tools.c,v 1.1.1.3.4.1.2.6 2001/07/29 16:06:05 serassio Exp $
+ * $Id: tools.c,v 1.1.1.3.4.1.2.6.2.1 2001/08/27 21:48:22 tolsty Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -33,14 +32,12 @@
  *
  */
 
+#define TOOLS_C
 #include "squid.h"
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 #include <windows.h>
 #include <psapi.h>
 #include <process.h>
-#ifdef _SQUID_MSWIN_
-#include <sys/timeb.h>
-#endif
 #endif
 
 #define DEAD_MSG "\
@@ -70,24 +67,12 @@
     /* Release the main ports as early as possible */
     for (i = 0; i < NHttpSockets; i++) {
 	if (HttpSockets[i] >= 0)
-#ifdef _SQUID_MSWIN_
-	    closesocket(HttpSockets[i]);
-#else
 	    close(HttpSockets[i]);
-#endif
     }
     if (theInIcpConnection >= 0)
-#ifdef _SQUID_MSWIN_
-	closesocket(theInIcpConnection);
-#else
 	close(theInIcpConnection);
-#endif
     if (theOutIcpConnection >= 0 && theOutIcpConnection != theInIcpConnection)
-#ifdef _SQUID_MSWIN_
-	closesocket(theOutIcpConnection);
-#else
 	close(theOutIcpConnection);
-#endif
 }
 
 static char *
@@ -134,8 +119,7 @@
     fprintf(debug_log, "\ttotal space in arena:  %6d KB\n",
 	(int) (ms.bytes_total >> 10));
     fprintf(debug_log, "\tTotal free:            %6d KB %d%%\n",
-	(int) (ms.bytes_free >> 10),
-	percent(ms.bytes_free, ms.bytes_total));
+	(int) (ms.bytes_free >> 10), percent(ms.bytes_free, ms.bytes_total));
 #elif HAVE_MALLINFO && HAVE_STRUCT_MALLINFO
     struct mallinfo mp;
     int t;
@@ -143,18 +127,15 @@
 	return;
     mp = mallinfo();
     fprintf(debug_log, "Memory usage for %s via mallinfo():\n", appname);
-    fprintf(debug_log, "\ttotal space in arena:  %6d KB\n",
-	mp.arena >> 10);
+    fprintf(debug_log, "\ttotal space in arena:  %6d KB\n", mp.arena >> 10);
     fprintf(debug_log, "\tOrdinary blocks:       %6d KB %6d blks\n",
 	mp.uordblks >> 10, mp.ordblks);
     fprintf(debug_log, "\tSmall blocks:          %6d KB %6d blks\n",
 	mp.usmblks >> 10, mp.smblks);
     fprintf(debug_log, "\tHolding blocks:        %6d KB %6d blks\n",
 	mp.hblkhd >> 10, mp.hblks);
-    fprintf(debug_log, "\tFree Small blocks:     %6d KB\n",
-	mp.fsmblks >> 10);
-    fprintf(debug_log, "\tFree Ordinary blocks:  %6d KB\n",
-	mp.fordblks >> 10);
+    fprintf(debug_log, "\tFree Small blocks:     %6d KB\n", mp.fsmblks >> 10);
+    fprintf(debug_log, "\tFree Ordinary blocks:  %6d KB\n", mp.fordblks >> 10);
     t = mp.uordblks + mp.usmblks + mp.hblkhd;
     fprintf(debug_log, "\tTotal in use:          %6d KB %d%%\n",
 	t >> 10, percent(t, mp.arena));
@@ -162,13 +143,12 @@
     fprintf(debug_log, "\tTotal free:            %6d KB %d%%\n",
 	t >> 10, percent(t, mp.arena));
 #if HAVE_EXT_MALLINFO
-    fprintf(debug_log, "\tmax size of small blocks:\t%d\n",
-	mp.mxfast);
+    fprintf(debug_log, "\tmax size of small blocks:\t%d\n", mp.mxfast);
     fprintf(debug_log, "\tnumber of small blocks in a holding block:\t%d\n",
 	mp.nlblks);
-    fprintf(debug_log, "\tsmall block rounding factor:\t%d\n",
-	mp.grain);
-    fprintf(debug_log, "\tspace (including overhead) allocated in ord. blks:\t%d\n",
+    fprintf(debug_log, "\tsmall block rounding factor:\t%d\n", mp.grain);
+    fprintf(debug_log,
+	"\tspace (including overhead) allocated in ord. blks:\t%d\n",
 	mp.uordbytes);
     fprintf(debug_log, "\tnumber of ordinary blocks allocated:\t%d\n",
 	mp.allocated);
@@ -194,35 +174,33 @@
     leave_suid();
 #endif
 #if HAVE_WIN32_PSAPI && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
-    if ((WIN32_OS_version == _WIN_OS_WINNT) || (WIN32_OS_version == _WIN_OS_WIN2K))
-    {
-    	/* On Windows NT/2000 call PSAPI.DLL for process Memory */
-    	/* informations -- Guido Serassio                       */
-    	HANDLE hProcess;
-    	PROCESS_MEMORY_COUNTERS pmc;
+    if ((WIN32_OS_version == _WIN_OS_WINNT)
+	|| (WIN32_OS_version == _WIN_OS_WIN2K)) {
+	/* On Windows NT/2000 call PSAPI.DLL for process Memory */
+	/* informations -- Guido Serassio                       */
+	HANDLE hProcess;
+	PROCESS_MEMORY_COUNTERS pmc;
 	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
-	    PROCESS_VM_READ,
-	    FALSE, GetCurrentProcessId());
+	    PROCESS_VM_READ, FALSE, GetCurrentProcessId());
 #if defined (_SQUID_MSWIN_)
 	{
-	/* Microsoft Visual C++ doesn't have getrusage function,  */
-	/* so we get process CPU time information from PSAPI.DLL. */
+	    /* Microsoft Visual C++ doesn't have getrusage function,  */
+	    /* so we get process CPU time information from PSAPI.DLL. */
 	    FILETIME ftCreate, ftExit, ftKernel, ftUser;
-	    if (GetProcessTimes(hProcess, &ftCreate, &ftExit, &ftKernel, &ftUser))
-	    {
-	    	LONGLONG tUser64 = *(LONGLONG *)&ftUser;
-		LONGLONG tKernel64 = *(LONGLONG *)&ftKernel;
-		r->ru_utime.tv_usec =(DWORD)(tUser64 / 10);
-		r->ru_stime.tv_usec =(DWORD)(tKernel64 / 10);
+	    if (GetProcessTimes(hProcess, &ftCreate, &ftExit, &ftKernel,
+		    &ftUser)) {
+		LONGLONG tUser64 = *(LONGLONG *) & ftUser;
+		LONGLONG tKernel64 = *(LONGLONG *) & ftKernel;
+		r->ru_utime.tv_usec = (DWORD) (tUser64 / 10);
+		r->ru_stime.tv_usec = (DWORD) (tKernel64 / 10);
 	    }
 	}
 #endif
-	if ( GetProcessMemoryInfo( hProcess, &pmc, sizeof(pmc)) )
-	{
-	    r->ru_maxrss=(DWORD)(pmc.WorkingSetSize /1024);
-	    r->ru_majflt=pmc.PageFaultCount;
+	if (GetProcessMemoryInfo(hProcess, &pmc, sizeof(pmc))) {
+	    r->ru_maxrss = (DWORD) (pmc.WorkingSetSize / 1024);
+	    r->ru_majflt = pmc.PageFaultCount;
 	}
-	CloseHandle( hProcess );
+	CloseHandle(hProcess);
     }
 #endif
 #endif
@@ -272,7 +250,6 @@
 #endif
 }
 
-
 void
 PrintRusage(void)
 {
@@ -281,14 +258,14 @@
     fprintf(debug_log, "CPU Usage: %.3f seconds = %.3f user + %.3f sys\n",
 	rusage_cputime(&rusage),
 	rusage.ru_utime.tv_sec + ((double) rusage.ru_utime.tv_usec / 1000000.0),
-	rusage.ru_stime.tv_sec + ((double) rusage.ru_stime.tv_usec / 1000000.0));
+	rusage.ru_stime.tv_sec +
+	((double) rusage.ru_stime.tv_usec / 1000000.0));
     fprintf(debug_log, "Maximum Resident Size: %d KB\n",
 	rusage_maxrss(&rusage));
     fprintf(debug_log, "Page faults with physical i/o: %d\n",
 	rusage_pagefaults(&rusage));
 }
 
-
 void
 death(int sig)
 {
@@ -338,7 +315,6 @@
     abort();
 }
 
-
 void
 sigusr2_handle(int sig)
 {
@@ -406,7 +382,7 @@
 /* printf-style interface for fatal */
 #if STDC_HEADERS
 void
-fatalf(const char *fmt,...)
+fatalf(const char *fmt, ...)
 {
     va_list args;
     va_start(args, fmt);
@@ -505,8 +481,7 @@
 	    /* use the official name from DNS lookup */
 	    xstrncpy(host, h->h_name, SQUIDHOSTNAMELEN);
 	    debug(50, 4) ("getMyHostname: resolved %s to '%s'\n",
-		inet_ntoa(Config.Sockaddr.http->s.sin_addr),
-		host);
+		inet_ntoa(Config.Sockaddr.http->s.sin_addr), host);
 	    present = 1;
 	    return host;
 	}
@@ -529,7 +504,8 @@
 	present = 1;
 	return host;
     }
-    fatal("Could not determine fully qualified hostname.  Please set 'visible_hostname'\n");
+    fatal
+	("Could not determine fully qualified hostname.  Please set 'visible_hostname'\n");
     return NULL;		/* keep compiler happy */
 }
 
@@ -556,7 +532,6 @@
 leave_suid(void)
 {
     debug(21, 3) ("leave_suid: PID %d called\n", getpid());
-#ifndef _SQUID_MSWIN_
     if (geteuid() != 0)
 	return;
     /* Started as a root, check suid option */
@@ -579,7 +554,6 @@
     if (setuid(Config2.effectiveUserID) < 0)
 	debug(50, 0) ("ALERT: setuid: %s\n", xstrerror());
 #endif
-#endif
 }
 
 /* Enter a privilegied section */
@@ -587,13 +561,11 @@
 enter_suid(void)
 {
     debug(21, 3) ("enter_suid: PID %d taking root priveleges\n", getpid());
-#ifndef _SQUID_MSWIN_
 #if HAVE_SETRESUID
     setresuid(-1, 0, -1);
 #else
     setuid(0);
 #endif
-#endif
 }
 
 /* Give up the posibility to gain privilegies.
@@ -606,7 +578,8 @@
     uid_t uid;
     leave_suid();
     uid = geteuid();
-    debug(21, 3) ("leave_suid: PID %d giving up root priveleges forever\n", getpid());
+    debug(21, 3) ("leave_suid: PID %d giving up root priveleges forever\n",
+	getpid());
 #if HAVE_SETRESUID
     if (setresuid(uid, uid, uid) < 0)
 	debug(50, 1) ("no_suid: setresuid: %s\n", xstrerror());
@@ -645,8 +618,7 @@
 }
 
 
-pid_t
-readPidFile(void)
+pid_t readPidFile(void)
 {
     FILE *pid_fp = NULL;
     const char *f = Config.pidFilename;
@@ -709,7 +681,8 @@
     }
 #endif
 #else /* HAVE_SETRLIMIT */
-    debug(21, 1) ("setMaxFD: Cannot increase: setrlimit() not supported on this system\n");
+    debug(21, 1)
+	("setMaxFD: Cannot increase: setrlimit() not supported on this system\n");
 #endif /* HAVE_SETRLIMIT */
 
 #if HAVE_SETRLIMIT && defined(RLIMIT_DATA)
@@ -738,8 +711,7 @@
 #endif /* RLIMIT_VMEM */
 }
 
-time_t
-getCurrentTime(void)
+time_t getCurrentTime(void)
 {
 #if GETTIMEOFDAY_NO_TZP
     gettimeofday(&current_time);
@@ -772,7 +744,8 @@
     sa.sa_flags = flags;
     sigemptyset(&sa.sa_mask);
     if (sigaction(sig, &sa, NULL) < 0)
-	debug(50, 0) ("sigaction: sig=%d func=%p: %s\n", sig, func, xstrerror());
+	debug(50, 0) ("sigaction: sig=%d func=%p: %s\n", sig, func,
+	    xstrerror());
 #else
     signal(sig, func);
 #endif
@@ -958,7 +931,7 @@
 {
     debug(21, 2) ("xrename: renaming %s to %s\n", from, to);
 #ifdef _SQUID_MSWIN_
-	remove(to);
+    remove(to);
 #endif
     if (0 == rename(from, to))
 	return 0;
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.1.1.3.4.1.2.3
retrieving revision 1.1.1.3.4.1.2.3.2.1
diff -u -r1.1.1.3.4.1.2.3 -r1.1.1.3.4.1.2.3.2.1
--- squid/src/typedefs.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.1.2.3
+++ squid/src/typedefs.h	27 Aug 2001 21:48:22 -0000	1.1.1.3.4.1.2.3.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: typedefs.h,v 1.1.1.3.4.1.2.3 2001/06/14 20:36:16 serassio Exp $
+ * $Id: typedefs.h,v 1.1.1.3.4.1.2.3.2.1 2001/08/27 21:48:22 tolsty Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -37,16 +36,20 @@
 typedef unsigned int swap_status_t;
 typedef signed int sfileno;
 
-typedef struct {
+typedef struct
+{
     size_t bytes;
     size_t kb;
-} kb_t;
+}
+kb_t;
 
-typedef struct {
+typedef struct
+{
     size_t count;
     size_t bytes;
     size_t gb;
-} gb_t;
+}
+gb_t;
 
 /*
  * grep '^struct' structs.h \
@@ -230,7 +233,8 @@
 typedef void STLOGCLEANWRITE(const StoreEntry *, SwapDir *);
 
 typedef double hbase_f(double);
-typedef void StatHistBinDumper(StoreEntry *, int idx, double val, double size, int count);
+typedef void StatHistBinDumper(StoreEntry *, int idx, double val, double size,
+    int count);
 
 /* append/vprintf's for Packer */
 typedef void (*append_f) (void *, const char *buf, int size);
Index: squid/src/unlinkd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/unlinkd.c,v
retrieving revision 1.1.1.3.4.1.2.1
retrieving revision 1.1.1.3.4.1.2.1.2.1
diff -u -r1.1.1.3.4.1.2.1 -r1.1.1.3.4.1.2.1.2.1
--- squid/src/unlinkd.c	6 Jan 2001 12:40:17 -0000	1.1.1.3.4.1.2.1
+++ squid/src/unlinkd.c	27 Aug 2001 21:48:22 -0000	1.1.1.3.4.1.2.1.2.1
@@ -1,5 +1,5 @@
 /*
- * $Id: unlinkd.c,v 1.1.1.3.4.1.2.1 2001/01/06 12:40:17 hno Exp $
+ * $Id: unlinkd.c,v 1.1.1.3.4.1.2.1.2.1 2001/08/27 21:48:22 tolsty Exp $
  *
  * DEBUG: section 12    Unlink Daemon
  * AUTHOR: Duane Wessels
@@ -36,6 +36,8 @@
 
 #ifdef UNLINK_DAEMON
 
+#include "globals.h"
+
 /* This is the external unlinkd process */
 
 #define UNLINK_BUF_LEN 1024
@@ -73,8 +75,27 @@
 static int unlinkd_rfd = -1;
 #endif
 
+#ifdef _SQUID_MSWIN_
+extern void sd_note(int fd, const char *s);
+
+static HANDLE hIpc;
+static pid_t pid;
+#endif
+
 #define UNLINKD_QUEUE_LIMIT 20
 
+static unsigned long n_successes = 0, n_failures = 0;
+static void
+unlinkdStats(StoreEntry * sentry)
+{
+    storeAppendPrintf(sentry, "Unlink Daemon Statistics:\n");
+    storeAppendPrintf(sentry,
+	"\nNumber of requests:  %lu\n"
+	"Number of successes: %lu\n"
+	"Number of failures:  %lu\n", Counter.unlink.requests, n_successes,
+	n_failures);
+}
+
 void
 unlinkdUnlink(const char *path)
 {
@@ -113,21 +134,41 @@
     if (queuelen > 0) {
 	int x;
 	int i;
-	char rbuf[512];
-	x = read(unlinkd_rfd, rbuf, 511);
+	static char rbuf[512];
+	static int offset = 0;
+#ifdef _SQUID_MSWIN_
+	x = recv(unlinkd_rfd, rbuf + offset, 511, 0);
+#else
+	x = read(unlinkd_rfd, rbuf + offset, 511);
+#endif
 	if (x > 0) {
-	    rbuf[x] = '\0';
+	    rbuf[x += offset] = '\0';
 	    for (i = 0; i < x; i++)
-		if ('\n' == rbuf[i])
+		if ('\n' == rbuf[i]) {
+		    if (strncmp(rbuf, "OK\r\n", 4) && strncmp(rbuf, "OK\n", 3))
+			n_failures++;
+		    else
+			n_successes++;
 		    queuelen--;
+		    i++;
+		    xmemmove(rbuf, rbuf + i, sizeof(rbuf) - i);
+		    x -= i;
+		    i = -1;
+		}
 	    assert(queuelen >= 0);
+	    assert(x >= 0);
+	    offset = x;
 	}
     }
     l = strlen(path);
     assert(l < MAXPATHLEN);
     xstrncpy(buf, path, MAXPATHLEN);
     buf[l++] = '\n';
+#ifdef _SQUID_MSWIN_
+    x = send(unlinkd_wfd, buf, l, 0);
+#else
     x = write(unlinkd_wfd, buf, l);
+#endif
     if (x < 0) {
 	debug(50, 1) ("unlinkdUnlink: write FD %d failed: %s\n",
 	    unlinkd_wfd, xstrerror());
@@ -148,20 +189,48 @@
 unlinkdClose(void)
 {
 #if USE_UNLINKD
-    assert(unlinkd_wfd > -1);
-    debug(12, 1) ("Closing unlinkd pipe on FD %d\n", unlinkd_wfd);
-    file_close(unlinkd_wfd);
-    if (unlinkd_wfd != unlinkd_rfd)
-	file_close(unlinkd_rfd);
-    unlinkd_wfd = -1;
-    unlinkd_rfd = -1;
+#ifdef _SQUID_MSWIN_
+    if (unlinkd_wfd > -1) {
+#else
+    {
+	assert(unlinkd_wfd > -1);
+#endif
+	debug(12, 1) ("Closing unlinkd pipe on FD %d\n", unlinkd_wfd);
+#ifdef _SQUID_MSWIN_
+	shutdown(unlinkd_wfd, SD_BOTH);
+	comm_close(unlinkd_wfd);
+	if (unlinkd_wfd != unlinkd_rfd)
+	    comm_close(unlinkd_rfd);
+#else
+	file_close(unlinkd_wfd);
+	if (unlinkd_wfd != unlinkd_rfd)
+	    file_close(unlinkd_rfd);
+#endif
+	unlinkd_wfd = -1;
+	unlinkd_rfd = -1;
+    }
+#ifdef _SQUID_MSWIN_
+    else {
+	debug(12, 0) ("unlinkdClose: WARNING: unlinkd_wfd is %d\n",
+	    unlinkd_wfd);
+    }
+    if (hIpc) {
+	if (WaitForSingleObject(hIpc, 5000) != WAIT_OBJECT_0) {
+	    getCurrentTime();
+	    debug(12, 1)
+		
+		("unlinkdClose: WARNING: (unlinkd,%ld) didn't exit in 5 seconds\n",
+		pid);
+	}
+	CloseHandle(hIpc);
+    }
+#endif
 #endif
 }
 
 void
 unlinkdInit(void)
 {
-#ifndef _SQUID_MSWIN_
 #if USE_UNLINKD
     int x;
     char *args[2];
@@ -171,21 +240,28 @@
 #if HAVE_POLL && defined(_SQUID_OSF_)
     /* pipes and poll() don't get along on DUNIX -DW */
     x = ipcCreate(IPC_TCP_SOCKET,
+#elif defined(_SQUID_MSWIN_)
+	/* select() will fail on a pipe */
+	x = ipcCreate(IPC_TCP_SOCKET,
 #else
     x = ipcCreate(IPC_FIFO,
 #endif
-	Config.Program.unlinkd,
-	args,
-	"unlinkd",
-	&unlinkd_rfd,
-	&unlinkd_wfd);
+	Config.Program.unlinkd, args, "unlinkd", &unlinkd_rfd, &unlinkd_wfd
+#ifdef _SQUID_MSWIN_
+	, &hIpc, &pid
+#endif
+	);
     if (x < 0)
 	fatal("Failed to create unlinkd subprocess");
     slp.tv_sec = 0;
     slp.tv_usec = 250000;
     select(0, NULL, NULL, NULL, &slp);
+#ifdef _SQUID_MSWIN_
+    sd_note(unlinkd_wfd, "squid <-> unlinkd");
+#else
     fd_note(unlinkd_wfd, "squid -> unlinkd");
     fd_note(unlinkd_rfd, "unlinkd -> squid");
+#endif
     commSetTimeout(unlinkd_rfd, -1, NULL, NULL);
     commSetTimeout(unlinkd_wfd, -1, NULL, NULL);
     /*
@@ -195,14 +271,20 @@
      * code to retry if we get EWOULDBLOCK.  Unfortunately, we can
      * do this only for the IPC_FIFO case.
      */
+#ifdef _SQUID_MSWIN_
+    assert(sd_table[unlinkd_rfd].flags.nonblocking);
+    if (FD_PIPE == sd_table[unlinkd_wfd].type)
+#else
     assert(fd_table[unlinkd_rfd].flags.nonblocking);
     if (FD_PIPE == fd_table[unlinkd_wfd].type)
+#endif
 	commUnsetNonBlocking(unlinkd_wfd);
     debug(12, 1) ("Unlinkd pipe opened on FD %d\n", unlinkd_wfd);
+    cachemgrRegister("unlinkd", "Unlink Daemon Stats", unlinkdStats, 0, 1);
+
 #else
     debug(12, 1) ("Unlinkd is disabled\n");
 #endif
-#endif
 }
 
 #endif /* ndef UNLINK_DAEMON */
